import java.awt.Color;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.Rectangle;

public class RectangleIcon implements SimulationIcon
{
    private Rectangle myRegion;
    private Color     myColor;
    private int       xDelta;
    private int       yDelta;

    public RectangleIcon( int x, int y, int width, int dx, int dy )
    {
        myRegion = new Rectangle( x, y, width, width);
        myColor  = Color.black;
        xDelta   = dx;
        yDelta   = dy;
    }

    public void draw( Graphics target )
    {
        target.setColor( myColor );
        target.fillRect( myRegion.x    , myRegion.y,
                         myRegion.width, myRegion.height );
    }

    public void move()
    {
        myRegion.setLocation( (int) myRegion.getX() + xDelta,
                              (int) myRegion.getY() + yDelta );
    }

    public int y()
    {
        return (int) myRegion.getY();
    }
}
