import java.awt.Button;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.Panel;
import java.awt.Point;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class SimulationFrame extends Frame
{
    private static final int FrameWidth  = 400;
    private static final int FrameHeight = 400;
    private static final int SleepTime   =  20;

    private SimulationIcon actor;

    public SimulationFrame()
    {
        setSize ( FrameWidth, FrameHeight );
        setTitle( "First Draft, Unix Simulation" );

        actor = null;

        add( "South", new InteractionPanel() );
    }

    public void paint( Graphics g )
    {
        g.drawString( "~/wallingf", 50, 40 );
        g.drawRect( 50, 50, 300, 300 );

        g.fillRect( 100, 100, 10, 10 );
        g.drawString( "index.html", 120, 110 );

        g.drawRect( 100, 250, 30, 30 );
        g.drawString( "062-dir", 140, 260 );

        g.fillRoundRect( 220, 250, 30, 30, 20, 20 );
        g.drawString( "lj4si", 260, 260 );

        if ( actor != null )
        {
            if ( actor.y() > 250 )
            {
                actor    = null;
            }
            else
            {
                actor.move();
                actor.draw( g );
                repaint();
            }
        }
    }

    public void simulateMove()
    {
        actor = new RectangleIcon( 100, 100, 10, 2, 15 );
        repaint();
    }

    public void simulatePrint()
    {
        actor = new CircleIcon( 100, 100, 5, 4, 5 );
        repaint();
    }

    private class InteractionPanel extends Panel
    {
        private TextField commandField;

        public InteractionPanel()
        {
            setLayout( new GridLayout( 1, 2 ) );

            commandField = new TextField();
            add( commandField );

            Button button = new Button( "simulate" );
            button.addActionListener( new SimulationButtonListener() );
            add( button );
        }

        private class SimulationButtonListener implements ActionListener
        {
            public void actionPerformed( ActionEvent e )
            {
                String command = commandField.getText();
                if ( command.startsWith( "mv" ) )
                    simulateMove();
                else if ( command.startsWith( "lp" ) )
                    simulatePrint();
            }
        }
    }
}
